#ifndef WINDOW_H
#define WINDOW_H

#include <QMainWindow>
#include "GlWidget.h"

#include "PadController.h"
#include "ChordSelector.h"
#include "PadStatBoxPlot.h"
#include "ChordSuggestor.h"

QT_BEGIN_NAMESPACE
class QSlider;
QT_END_NAMESPACE

class Window : public QMainWindow
{
    Q_OBJECT

public:
    Window();

    GLWidget& glWidget(){ return _glWidget; }

    void chordSelector( ChordSelector* c ){ _chordSelector = c; }
    void padController( PadController* pc ){ _padController = pc; }
    void padPlot( PadStatBoxPlot* p ){ _padPlot = p; }
    void chordSuggestor( ChordSuggestor* cs ){ _chordSuggestor = cs; }
    void suggestLabel( GfxFtStringObject* s ){ _suggestLabel = s; }
    
    void setPlayMode( bool b );
    
protected:
    void keyPressEvent(QKeyEvent *event);
    void keyReleaseEvent(QKeyEvent *event);

private:
    GLWidget _glWidget;
    
    // object pointers for layout. 
    // TODO: layout should be handled in the glwidget...
    PadController* _padController;
    ChordSelector* _chordSelector;
    PadStatBoxPlot* _padPlot;
    ChordSuggestor* _chordSuggestor;
    GfxFtStringObject* _suggestLabel;

    void createMenus();

    void handleAddChord();
    void dumpChordColumn();
    void pressPad( unsigned int i );
    void releasePad( unsigned int i );
    void clearPad( unsigned int i );
    
public slots:
    void savePadToFile();
    void openPadDataFile();
};

#endif
