#ifndef _GFXFTSTRINGOBJECT_H_
#define _GFXFTSTRINGOBJECT_H_

#include "GfxObject.h"

#include <FTGL/ftgl.h>

class GfxFtStringObject: public GfxObject 
{
public:
	GfxFtStringObject( const char* fontPath = "fonts/FreeSans.ttf" );
	GfxFtStringObject( string& s, 
        const char* fontPath = "fonts/FreeSans.ttf" );
	virtual ~GfxFtStringObject();

    float width();
    float height();

    void setText( string& t );
    void setText( const char* s );
    void setFontSize( unsigned int s );
    void setDepth( float d );

protected:
    /**
     * Renders the object.
     */
    virtual void drawComponent();

private:
	string _text;
    FTExtrudeFont _font;
    
    unsigned int _size;
    float _depth;
};

#endif // _GFXFTSTRINGOBJECT_H_
