DESTDIR = ./bin
OBJECTS_DIR = ./bin/objects

LIBS += -lpthread -ljack -lasound -lglut -lftgl
DEFINES += __UNIX_JACK__ __LINUX_ALSASEQ__

VPATH = /usr/include/freetype2 \
        ./gfx ./gfx/object \
        ./midi \
        ./key \
        ./pad ./pad/gfx ./pad/midi  \
        ./music ./music/scale \
        ./xml ./util \
        ./select \
        ./stat ./stat/map
INCLUDEPATH = /usr/include/freetype2 \
              ./gfx ./gfx/object \
              ./midi \
              ./key \
              ./pad ./pad/gfx ./pad/midi  \
              ./music ./music/scale \
              ./xml ./util \
              ./select \
              ./stat ./stat/map
HEADERS       = Common.h ClassException.h Interpolator.h CommonUtil.h \
                tinystr.h tinyxml.h \
                XmlPrinter.h \
                GlWidget.h Window.h \
                GfxObject.h GfxBoxObject.h \
                GfxStringObject.h GfxFtStringObject.h \
                RtMidi.h RtError.h \
                MidiEngine.h MidiEvent.h \
                MidiRemapper.h ChordSuggestor.h \
                PadData.h PadEvent.h PadEventListener.h \
                PadControllerObject.h PadObject.h PadTextObject.h \
                PadController.h \
                KeyState.h KeyStateListener.h KeyStateLabel.h \
                Chord.h ModeFactory.h ScaleMode.h \
                MajorMode.h MinorMode.h MinorHMode.h LydianMode.h \
                ChordColumn.h ChordItem.h ChordSelector.h \
                PadStatistics.h PadStatsListener.h PadStatBoxPlot.h \
                SuggestMap.h TonalMap.h TextSuggestor.h
SOURCES       = main.cpp \
                ClassException.cpp Interpolator.cpp CommonUtil.cpp \
                tinystr.cpp tinyxml.cpp tinyxmlerror.cpp tinyxmlparser.cpp \
                XmlPrinter.cpp \
                GlWidget.cpp Window.cpp \
                GfxObject.cpp GfxBoxObject.cpp \
                GfxStringObject.cpp GfxFtStringObject.cpp \
                RtMidi.cpp \
                MidiEngine.cpp MidiEvent.cpp \
                MidiRemapper.cpp ChordSuggestor.cpp \
                PadData.cpp PadEvent.cpp \
                PadControllerObject.cpp PadObject.cpp PadTextObject.cpp \
                PadController.cpp \
                KeyState.cpp KeyStateLabel.cpp \
                Chord.cpp ModeFactory.cpp ScaleMode.cpp \
                MajorMode.cpp MinorMode.cpp MinorHMode.cpp LydianMode.cpp \
                ChordColumn.cpp ChordItem.cpp ChordSelector.cpp \
                PadStatistics.cpp PadStatBoxPlot.cpp \
                TonalMap.cpp TextSuggestor.cpp
QT           += opengl
