#ifndef _KEYSTATE_H_
#define _KEYSTATE_H_

#include "ModeFactory.h"
#include "KeyStateListener.h"

class KeyState
{
public:
	static KeyState* INSTANCE();

    static string getKeyString( int key );

private:
	KeyState();
	~KeyState();

	static KeyState* _singleton;

public:
    void addListener( KeyStateListener* l );
    int scaleToNote( unsigned int i, unsigned int o );

    void key( int i );
    int key(){ return _key; };
    string keyString(){ return getKeyString( _key ); }
    
    void mode( ScaleModeName smn );
    ScaleModeName mode(){ return _mode->scaleModeName(); }
    string& modeName(){ return _mode->toString(); }

    bool isPlayMode(){ return _playMode; }
    void playMode( bool p ){ _playMode = p; }

private:
    vector<KeyStateListener*> _listeners;
    
	int _key; // C = 0, C#/Db = 1, ...
                    // range 0 ~ 12
	ScaleMode* _mode;

    bool _playMode; // TODO: move to application state managing class.

    void fireStateChanged();
};

#endif // _KEYSTATE_H_
