#include "KeyStateLabel.h"

#include "KeyState.h"

string keyText("Key: ");
string modeText("Mode: ");

/**
 * Constructor
 */
KeyStateLabel::KeyStateLabel()
{
    _keyLabel.setFontSize( 7 );
    _keyLabel.translate( 0, 0, 0 );
    _keyLabel.color( 255, 255, 255 );
    _keyLabel.emission( 1 );

    _modeLabel.setFontSize( 7 );
    _modeLabel.translate( 50, 0, 0 );
    _modeLabel.color( 255, 255, 255 );
    _modeLabel.emission( 1 );
}

/**
 * Destructor
 */
KeyStateLabel::~KeyStateLabel()
{
}

/**
 * Updates the text
 */
void KeyStateLabel::updateText()
{
    KeyState* keyState = KeyState::INSTANCE();

    // key
    string keyStrText( keyText );
    keyStrText += keyState->keyString();

    _keyLabel.setText( keyStrText );

    // mode
    string modeStrText( modeText );
    modeStrText += keyState->modeName();

    _modeLabel.setText( modeStrText );
}

// @Override
void KeyStateLabel::drawComponent()
{
	_keyLabel.drawObject();
	_modeLabel.drawObject();
}