#ifndef _CHORD_H_
#define _CHORD_H_

#include "Common.h"
#include <vector>

class Chord
{
public:
    Chord();
    Chord( Chord& c );
    ~Chord();

    void copy( Chord& c );
    bool contains( Chord& c );
    unsigned int compare( Chord& c );

    void clear();
    
	void addScaleValue( unsigned int i );
	vector<int>* scaleValues(){ return &_scaleValues; }
	unsigned int noteCount(){ return _scaleValues.size(); }

    void octave( int i );    
    int octave(){ return _octave; };

    unsigned int root();

    void label( string& l ){ _label = l; }
    string& label();

	void print();

private:
	vector<int> _scaleValues;
	int _octave; // range 1+
    string _label;
};

#endif // _CHORD_H_
