#ifndef _MODEFACTORY_H_
#define _MODEFACTORY_H_

#include "ScaleMode.h"
#include <vector>

/**
 * A factory-like class for accessing ScaleModes.
 * This class may cause memory leaks.
 * TODO: implement destroyer method if necessary.
 */
class ModeFactory
{
public:
    static ModeFactory* INSTANCE();

private:
    static ModeFactory* _singleton;

    ModeFactory();
    ~ModeFactory();

public:
    ScaleModeName nextMode( ScaleModeName s );
    ScaleModeName prevMode( ScaleModeName s );
    ScaleMode* getScaleMode( ScaleModeName s );

private:
    void initialize();

    vector<ScaleMode*> _scales;
};

#endif // _MODEFACTORY_H_
