#include "ScaleMode.h"

/**
 * Constructor
 */
ScaleMode::ScaleMode( ScaleModeName name, const char* s )
:_name(name)
,_nameString(s)
{
}

/**
 * Destructor
 */
ScaleMode::~ScaleMode()
{
}

/**
 * Returns the MIDI note offset value for the given scale number.
 * @param i the scale number. ranges from 1 to 8;
 */
int ScaleMode::scaleToNote( unsigned int i )
{
    assert( i > 0 );
    assert( _offsets.size() == 8 );

    unsigned int note =  (i-1) % 7;
    unsigned int octave = (i-1) / 7;

    return _offsets[note] + octave*12;
}