#ifndef _PADCONTROLLER_H_
#define _PADCONTROLLER_H_

#include "Common.h"

#include "MidiEngine.h"

#include "PadControllerObject.h"
#include "MidiRemapper.h"

/**
 * The pad controller object. This class contains the PadControllerObject(View) 
 * and the MidiRemapper(Model). In that sense this is the Controller of the MVC.
 */
class PadController: public KeyStateListener
{
public:
	PadController( MidiEngine& m );
	~PadController();

    MidiRemapper& midiRemapper(){ return _midiRemapper; }
    PadControllerObject& pcObject(){ return _pcObject; }

    bool addChord( Chord& c );
    void clearPad( unsigned int i );
    void clearAll();

    void updateUI();
	 
    virtual void handleKeyStateChanged();
private:
	PadControllerObject _pcObject;
	MidiRemapper _midiRemapper;
};

#endif // _PADCONTROLLER_H_
