#ifndef _PADCONTROLLEROBJECT_H_
#define _PADCONTROLLEROBJECT_H_

#include "Common.h"

#include <vector>

#include "PadTextObject.h"
#include "PadEventListener.h"

#define NUM_PADS 16

/**
 * The GfxObject representation of a pad controller.
 * NOTE: This is a composite object.
 */
class PadControllerObject: public GfxObject, public PadEventListener
{
public:
	PadControllerObject();
	virtual ~PadControllerObject();

    PadTextObject& pad( int i ){ assert( i < NUM_PADS ); return _pads[i]; }
    unsigned int numPads(){ return NUM_PADS; }

	virtual void handlePadEvent( PadEvent& e );

    void clearPad( unsigned int i );
    void clearPads();

protected:
	virtual void drawComponent();

private:
	GfxBoxObject _body;
	GfxBoxObject _padRim;
	PadTextObject _pads[NUM_PADS];

    vector<GfxObject*> _objects;

	void initialize();
};

#endif // _PADCONTROLLEROBJECT_H_
