#ifndef _PADOBJECT_H_
#define _PADOBJECT_H_

#include "GfxBoxObject.h"
#include "GfxFtStringObject.h"

enum PadState
{
	PS_IDLE = 0,
	PS_HIT,
	PS_SUGGEST,
	PS_COUNT
};

class PadObject: public GfxBoxObject 
{
public:
	static QColor IDLE_COLOR;
	static QColor HIT_COLOR;
	static QColor SUGGEST_COLOR;
	
public:
	PadObject( float width = 1, float height = 1, float depth = 1 );
    virtual ~PadObject();

	void idle();
	void hit( float v = 1 );
	void suggest( float v = 1 );
    
    bool isHit(){ return _padState == PS_HIT; }
    bool isSuggested(){ return _padState == PS_SUGGEST; }
	
    void color( int r, int g, int b, int a = 255 );
    void color( QColor& c );

protected:
    virtual void drawComponent();

private:
	PadState _padState;
	
	QColor _currentColor;
	float _mix;
    float _suggest;

    struct timeval _then;
	unsigned int _period; // period of pulsing in sec.
	float _lb;
	float _ub;
    
    GfxFtStringObject _textObject; // this class should be a composite class...
};

#endif // _PADOBJECT_H_
