/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * PadTextObject.cpp
 * 
 */

#include "PadTextObject.h"

/**
 * Constructor
 */
PadTextObject::PadTextObject( float width, float height, float depth )
:_padObject(width, height, depth)
{	
	string t = "empty";
    _textObject.setFontSize( 5 );
    _textObject.setText( t );
    _textObject.setDepth( 0.2 );
	_textObject.translate( 2, 2, 3 );
    _textObject.emission( 1 );
    _textObject.color( 16, 16, 16 );

	string o = "-";
    _octaveObject.setFontSize( 4 );
    _octaveObject.setText( o );
    _octaveObject.setDepth( 0.2 );
	_octaveObject.translate( 2,
	                        20 - 2 - _octaveObject.height(),
	                        3 );
	
    _octaveObject.emission( 1 );
    _octaveObject.color( 16, 16, 16 );
}

/**
 * Constructor
 */
PadTextObject::~PadTextObject()
{
}

/**
 * Sets the octave text
 */
void PadTextObject::setOctave( unsigned int i )
{
	string os;
	if( i < 1 ) os.append( "-" );
	else os += (i-1) + '1';

    _octaveObject.setText( os );
	_octaveObject.translate( 2, 
	                        20 - 2 - _octaveObject.height(), 
	                        3 );
}

// @Override
void PadTextObject::drawComponent()
{
	_textObject.drawObject();
	_octaveObject.drawObject();
	_padObject.drawObject();
}