#ifndef _PADTEXTOBJECT_H_
#define _PADTEXTOBJECT_H_

#include "PadObject.h"

class PadTextObject: public GfxObject 
{
public:
	PadTextObject( float width = 1, float height = 1, float depth = 1 );
	virtual ~PadTextObject();

	PadObject& padObject(){ return _padObject; }
	
	// delegate methods
	void idle(){ _padObject.idle(); }
	void hit( float v = 1 ){ _padObject.hit( v ); }
	void suggest( float v = 1 ){ _padObject.suggest( v ); }
    
    bool isHit(){ return _padObject.isHit(); }
    bool isSuggested(){ return _padObject.isSuggested(); }
	
    void color( int r, int g, int b, int a = 255 ){ 
		_padObject.color( r, g, b, a ); }
    void color( QColor& c ){ _padObject.color( c ); }

	void setText( string& s ){ _textObject.setText( s ); }
	void setText( const char* s ){ _textObject.setText( s ); }
	void setOctave( unsigned int i );

protected:
    virtual void drawComponent();

private:
	PadObject _padObject;
	GfxFtStringObject _textObject;
	GfxFtStringObject _octaveObject;
};

#endif // _PADTEXTOBJECT_H_
