#ifndef _MIDIREMAPPER_H_
#define _MIDIREMAPPER_H_

#include <map>

#include "MidiEngineListener.h"
#include "KeyStateListener.h"

#include "PadEventListener.h"
#include "MidiEngine.h"
#include "PadData.h"

/**
 * The Midi event remapping class. The PadData is here.
 */
class MidiRemapper : public MidiEngineListener 
{
public:
	MidiRemapper( MidiEngine& e );
	virtual ~MidiRemapper();

	void initialize();

    void addPadEventListener( PadEventListener* l );
    void updatePadChords();
    void setPadChord( unsigned int iputNote, Chord& c );
    bool addChord( Chord& c, unsigned int* id );
    void clearAllData();

	PadData& padData( unsigned int id );
    void sendPadMidi( unsigned int id, MidiEvent& e );
    unsigned int numPads(){ return _padIdList.size(); }

	virtual void handleMidiMessage( MidiEvent& e );
	
private:
	MidiEngine& _midiEngine;

	/** The pad data map. The input note value is used as the key. */
    map<int, PadData> _padMap;
	vector<int> _padIdList;

    vector<PadEventListener*> _listeners;

	void initPadData();
    void firePadEvent( PadEvent& e );
};

#endif // _MIDIREMAPPER_H_
