#ifndef _PADDATA_H_
#define _PADDATA_H_

#include <vector>

#include "Chord.h"

class PadData
{
public:
	PadData( unsigned int id = 0, unsigned int b = 0 );
	PadData( const PadData& p );
	~PadData();

	void id( unsigned int id );
	unsigned int id(){ return _id; }
    
	void inputNote( int v );
	int inputNote(){ return _inputNote; }
	
    void setChord( Chord& c );
	Chord& chord(){ return _chord; }

	vector<int>* outputNotes(){ return &_outputNotes; }

    void update();
    void clear();

private:
	/** The pad UI ID number */
	unsigned int _id;
    
	/** The pad UI bank number */
	unsigned int _bank; // TODO: implement bank handling code

	/** The MIDI input (pitch) value */
	int _inputNote;

    /** The chord to play */
    Chord _chord;

	/** The MIDI output pitch values */
	vector<int> _outputNotes;
	
	void clearOutputNotes();
	void addOutputNote( int v );
};

#endif // _PADDATA_H_
