#ifndef _CHORDCOLUMN_H_
#define _CHORDCOLUMN_H_

#include <vector>
#include "MidiEngine.h"
#include "ChordItem.h"
#include "GfxFtStringObject.h"
#include "Chord.h"

#define ITEMS_PER_COL 8

class ChordColumn: public GfxObject 
{    
public:
	ChordColumn( MidiEngine& m );
	virtual ~ChordColumn();

    void setTitle( string& s );
    void setTitle( const char* s );

	void next();
	void prev();
	void selectChord( unsigned int i );//{ assert( i < 7 ); _selectIdx = i; }
	unsigned int selectIdx(){ return _selectIdx; }

    void play();
    void stop();

    void setChords( Chord& c );
    void setChordLabel( unsigned int i, string& s );
    void setOctave( unsigned int octave );
    
    string& currentName(){ return _chords[_selectIdx].label(); }
    Chord& currentChord(){ return _chords[_selectIdx]; }

    Chord& getChord( unsigned int i )
        { assert( i < ITEMS_PER_COL ); return _chords[i]; }
    ChordItem& getChordItem( unsigned int i )
        { assert( i < ITEMS_PER_COL ); return _chordObjects[i]; }

protected:
	virtual void drawComponent();

private:
    MidiEngine& _midiEngine;
	GfxFtStringObject _titleObject;
    GfxBoxObject _selectIcon;
    
	unsigned int _selectIdx;
	ChordItem _chordObjects[ITEMS_PER_COL];
    Chord _chords[ITEMS_PER_COL];

    vector<GfxObject*> _objects;
    
    bool _isPlaying;

	void initialize();
};

#endif // _CHORDCOLUMN_H_
