#ifndef _CHORDITEM_H_
#define _CHORDITEM_H_

#include "GfxBoxObject.h"
#include "GfxFtStringObject.h"

class ChordItem: public GfxObject 
{
public:
    static int ITEM_WIDTH;
    static int ITEM_HEIGHT;
    
	static QColor IDLE_COLOR;
	static QColor SELECT_COLOR;
	static QColor SUGGEST_COLOR;
    
public:
	ChordItem();
	virtual ~ChordItem();

	void setText( string& s );

    void idle();
    void select();
    bool isSelected(){ return _isSelected; }
    void suggest( float v = 1 );

protected:
    virtual void drawComponent();
	
private:
	void initialize();
	
	GfxFtStringObject _textObject;
	GfxBoxObject _boxObject;
    bool _isSelected;
    bool _isSuggested;
};

#endif // _CHORDITEM_H_