#ifndef _CHORDSELECTOR_H_
#define _CHORDSELECTOR_H_

#include "GfxObject.h"
#include "ChordColumn.h"
#include "Interpolator.h"

class ChordSelector: public GfxObject
{
public:
	ChordSelector( MidiEngine& m );
	virtual ~ChordSelector();

	ChordColumn* currentColumn();
    Chord* currentChord();
    
	ChordColumn* getColumn( unsigned int i )
        { assert( i < _columns.size() ); return _columns.at(i); }
    unsigned int columnCount(){ return _columns.size(); }

	void nextColumn();
	void prevColumn();

    void incOctave();
    void decOctave();

    void translate( float x, float y, float z );
    void show();
    void hide();
	
	// delegate methods
	void next();
	void prev();

    void play();
    void stop();
	
protected:
	virtual void drawComponent();

private:
    MidiEngine& _midiEngine;
	unsigned int _currentIdx;
	vector<ChordColumn*> _columns;
    unsigned int _octave;
	GfxFtStringObject _octaveObject;
	vector<GfxBoxObject*> _columnDots;
    
    Interpolator _xInt;
    float _xPos;
    float _outPos;

	void initialize();
    void addChordColumn( const char* label, Chord& c, bool isInterval, 
                        const char* append = NULL );
    void selectColumn( unsigned int i );
    void updateColumns();
};

#endif // _CHORDSELECTOR_H_
