#ifndef _CHORDSUGGESTOR_H_
#define _CHORDSUGGESTOR_H_

#include <vector>

#include "PadControllerObject.h"
#include "MidiRemapper.h"
#include "ChordSelector.h"
#include "PadStatistics.h"

#include "SuggestMap.h"
#include "TonalMap.h"

class ChordSuggestor : public PadEventListener
{
public:
	ChordSuggestor( MidiRemapper& m, PadControllerObject& p, ChordSelector& c,
                   PadStatistics& ps );
	~ChordSuggestor();

    void useStats( bool b );
    bool isUsingStats(){ return _useStats; }
	
    virtual void handlePadEvent( PadEvent& e );

private:
	MidiRemapper& _midiMap;
	PadControllerObject& _pcObject;
    ChordSelector& _chordSelector;
    PadStatistics& _padStats;

    SuggestMap* _suggestMap;
    TonalMap _tonalMap;
    bool _useStats;

    void suggestTonal( PadEvent& e );
    void suggestStats( PadEvent& e );

    void lightPads( PadEvent& e, Chord& sc, float mix = 1 );
    void lightChordItems( PadEvent& e, Chord& sc, float mix = 1 );
};

#endif // _CHORDSUGGESTOR_H_
