#ifndef _PADSTATBOXPLOT_H_
#define _PADSTATBOXPLOT_H_

#include <QColor>
#include "GfxBoxObject.h"
#include "PadStatistics.h"
#include "Interpolator.h"

class PadStatBoxPlot: public GfxObject, public PadStatsListener
{
public:	
	static QColor MIN_COLOR;
	static QColor MAX_COLOR;
	
public:
	PadStatBoxPlot( PadStatistics& ps );
	virtual ~PadStatBoxPlot();

    void reset(){ _padStats.reset(); }

    void translate( float x, float y, float z );
    void show();
    void hide();
    
	void enableDepth( bool b );
	bool isDepthEnabled(){ return _enableDepth; }
	
	virtual void handleChange();

protected:
	virtual void drawComponent();

private:
	PadStatistics& _padStats;
	GfxBoxObject _boxObjects[49];
	bool _enableDepth;
    
    Interpolator _xInt;
    float _xPos;
    float _outPos;

	void initialize();
	void updateData();
};

#endif // _PADSTATBOXPLOT_H_
