#ifndef _PADSTATISTICS_H_
#define _PADSTATISTICS_H_

#include "PadEventListener.h"
#include "PadStatsListener.h"
#include "SuggestMap.h"

class PadStatistics: public PadEventListener, public SuggestMap
{
public:
    PadStatistics();
    ~PadStatistics();

    void reset();

    unsigned int* countArray(){ return _countArray; }
    unsigned int* columnSum(){ return _columnSum; }

    void addListener( PadStatsListener* l ){ _listeners.push_back( l ); }
    
    virtual void handlePadEvent( PadEvent& e );
	virtual vector<unsigned int>& getSuggestion( unsigned int i );

    void printArray();
    unsigned int root(){ return _prevRoot; }

private:
    unsigned int _countArray[49];
    unsigned int _columnSum[7];
    unsigned int _prevRoot;

    vector<PadStatsListener*> _listeners;
    vector<unsigned int> _suggestList;

    void fireEvent();
};

#endif // _PADSTATISTICS_H_