#ifndef _INTERPOLATOR_H_
#define _INTERPOLATOR_H_

class Interpolator
{
public:
	Interpolator( float v = 0, float g = 0, float s = 1 );
    Interpolator( const Interpolator& i );
	~Interpolator();

    inline float value(){ return _value; }
    inline void value( float v ){ _value = v; }
    inline float goal(){ return _goal; }
    inline void goal( float g ){ _goal = g; }
    inline float slew(){ return _slew; }
    inline void slew( float s ){ _slew = s; }

	inline void interpolate(){ _value = ( _goal - _value ) * _slew + _value; }
    inline void interpolate( float delta ){ _value = ( _goal - _value ) * _slew * 
			delta + _value; }

private:
	float _value;
	float _goal;
	float _slew;
};

#endif // _INTERPOLATOR_H_
